/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import engine.*;
import javax.microedition.lcdui.*;
import javax.microedition.m3g.*;




/**
 * @author DDDEN!SSS
 */
public class MyCanvas extends Canvas implements Runnable {
    
    private final Transform m3gMatrix = new Transform();
    private final Matrix matrix = new Matrix();
    private final Figure figure = new Figure(Main.main.getFile("/res/cube.txt"));
    
    private int key;
    private Thread thread;
    private boolean running;
    private boolean rot = true; //true-rotation
    
    private static final Font font = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL);
    
    public MyCanvas() {
        setFullScreenMode(true);
        m3gMatrix.postTranslate(0, 0, 600);
    }

    public void threadStart() {
        thread = new Thread(this);
        running = true;
        thread.start();
    }

    public void paint(Graphics g) {
        g.setColor(0xeeeeee);
        g.fillRect(0, 0, Main.width, Main.height);
        g.setFont(font);
        
        G3D.removeAll();
        G3D.addFigure(figure);
        G3D.render(g);
        
        g.setColor(0x000000);
        g.drawString("fps "+Fps.fps(), Main.width-50, 0, 0);
        g.drawString("x"+matrix.m03, 0, 0, 0);
        g.drawString("y"+matrix.m13, 0, font.getHeight(), 0);
        g.drawString("z"+matrix.m23, 0, font.getHeight()*2, 0);
    }

    protected void keyPressed(int k) {
        key = k;
        if(k == 53) {
            rot = Main.flag(rot);
        }
    }

    protected void keyReleased(int k) {
        key = 0;
    }
    
    
    private void rot(int k) {
        switch (k) {
            case 52 : m3gMatrix.postRotate(-3, 0, 1, 0); break;
            case 54 : m3gMatrix.postRotate(3, 0, 1, 0); break;
            
            case 50 : m3gMatrix.postRotate(-3, 1, 0, 0); break;
            case 56 : m3gMatrix.postRotate(3, 1, 0, 0); break;
            
            case 49 : m3gMatrix.postRotate(-3, 0, 0, 1); break;
            case 51 : m3gMatrix.postRotate(3, 0, 0, 1); break;
            
        }
        matrix.set(m3gMatrix);
        figure.setMatrix(matrix);
    }
    
    private void move(int k) {
        switch (k) {
            case 52 : matrix.m03-=10; matrix.get(m3gMatrix); break;
            case 54 : matrix.m03+=10; matrix.get(m3gMatrix); break;
            
            case 50 : matrix.m13-=10; matrix.get(m3gMatrix); break;
            case 56 : matrix.m13+=10; matrix.get(m3gMatrix); break;
            
            case 49 : matrix.m23+=10; matrix.get(m3gMatrix); break;
            case 51 : matrix.m23-=10; matrix.get(m3gMatrix); break;
            
        }
        matrix.set(m3gMatrix);
        figure.setMatrix(matrix);
    }
    

    public void run() {
        while (running) {
            if(rot) {
                rot(key);
            } else {
                move(key);
            }
            
            
            
            
            if(key==42) {
                G3D.pers--;
            }
            if(key==35) {
                G3D.pers++;
            }
            repaint();
            
            try {
                Thread.sleep(1L);
            } catch (Exception ex) {ex.printStackTrace();}
        }
    }
}